Index: /trunk/src/sys/arch/mips/include/ieee.h
===================================================================
--- /trunk/src/sys/arch/mips/include/ieee.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/ieee.h	(revision 152)
@@ -1,13 +1,136 @@
-/*	$NetBSD: ieee.h,v 1.5 2005/12/11 12:18:09 christos Exp $ */
+/*	$NetBSD: ieee.h,v 1.5.96.1 2011/04/29 07:48:36 matt Exp $	*/
+
+/*
+ * Copyright (c) 1992, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * This software was developed by the Computer Systems Engineering group
+ * at Lawrence Berkeley Laboratory under DARPA contract BG 91-66 and
+ * contributed to Berkeley.
+ *
+ * All advertising materials mentioning features or use of this software
+ * must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Lawrence Berkeley Laboratory.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)ieee.h	8.1 (Berkeley) 6/11/93
+ */
+
+/*
+ * ieee.h defines the machine-dependent layout of the machine's IEEE
+ * floating point.  It does *not* define (yet?) any of the rounding
+ * mode bits, exceptions, and so forth.
+ */
+
+#ifndef _MIPS_IEEE_H
+#define _MIPS_IEEE_H
 
 #include <sys/ieee754.h>
 
 /*
- * A NaN is a `signalling NaN' if its QUIETNAN bit is set in its
- * high fraction; if the bit is clear, it is a `quiet NaN'.
+ * The SPARC architecture defines the following IEEE 754 compliant
+ * 128-bit extended-precision format, which is supported only by the
+ * v9 toolchain.
  */
+
+#if defined(__mips_n32) || defined(__mips_n64)
+
+#define	EXT_EXPBITS	15
+#define EXT_FRACHBITS	16
+#define	EXT_FRACHMBITS	32
+#define	EXT_FRACLMBITS	32
+#define	EXT_FRACLBITS	32
+#define	EXT_FRACBITS	(EXT_FRACLBITS + EXT_FRACLMBITS + EXT_FRACHMBITS + EXT_FRACHBITS)
+
+#define	EXT_TO_ARRAY32(u, a) do {			\
+	(a)[0] = (uint32_t)(u).extu_ext.ext_fracl;	\
+	(a)[1] = (uint32_t)(u).extu_ext.ext_fraclm;	\
+	(a)[2] = (uint32_t)(u).extu_ext.ext_frachm;	\
+	(a)[3] = (uint32_t)(u).extu_ext.ext_frach;	\
+} while(/*CONSTCOND*/0)
+
+struct ieee_ext {
+#if _BYTE_ORDER == _BIG_ENDIAN
+	u_int	ext_sign:1;
+	u_int	ext_exp:EXT_EXPBITS;
+	u_int	ext_frach:EXT_FRACHBITS;
+	u_int	ext_frachm;
+	u_int	ext_fraclm;
+	u_int	ext_fracl;
+#else
+	u_int	ext_fracl;
+	u_int	ext_fraclm;
+	u_int	ext_frachm;
+	u_int	ext_frach:EXT_FRACHBITS;
+	u_int	ext_exp:EXT_EXPBITS;
+	u_int	ext_sign:1;
+#endif
+};
+
+/*
+ * Floats whose exponent is in [1..INFNAN) (of whatever type) are
+ * `normal'.  Floats whose exponent is INFNAN are either Inf or NaN.
+ * Floats whose exponent is zero are either zero (iff all fraction
+ * bits are zero) or subnormal values.
+ *
+ * A NaN is a `signalling NaN' if its QUIETNAN bit is clear in its
+ * high fraction; if the bit is set, it is a `quiet NaN'.
+ */
+#define	EXT_EXP_INFNAN	0x7fff
+#define	EXT_EXP_INF	0x7fff
+#define	EXT_EXP_NAN	0x7fff
 
 #if 0
 #define	SNG_QUIETNAN	(1 << 22)
 #define	DBL_QUIETNAN	(1 << 19)
+#define	EXT_QUIETNAN	(1 << 15)
 #endif
+
+/*
+ * Exponent biases.
+ */
+#define	EXT_EXP_BIAS	16383
+
+/*
+ * Convenience data structures.
+ */
+union ieee_ext_u {
+	long double		extu_ld;
+	struct ieee_ext		extu_ext;
+};
+
+#define extu_exp	extu_ext.ext_exp
+#define extu_sign	extu_ext.ext_sign
+#define extu_fracl	extu_ext.ext_fracl
+#define extu_frach	extu_ext.ext_frach
+
+#define LDBL_NBIT	0x80000000
+#define mask_nbit_l(u)	((u).extu_frach &= ~LDBL_NBIT)
+
+#endif /* __mips_n32 || __mips_n64 */
+
+#endif /* _MIPS_IEEE_H */
Index: /trunk/src/sys/arch/mips/include/ieeefp.h
===================================================================
--- /trunk/src/sys/arch/mips/include/ieeefp.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/ieeefp.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ieeefp.h,v 1.5 2008/08/05 16:47:42 matt Exp $	*/
+/*	$NetBSD: ieeefp.h,v 1.5.12.1 2011/04/29 07:48:36 matt Exp $	*/
 
 /*
@@ -17,7 +17,7 @@
 
 #define	FE_INEXACT	0x01	/* imprecise (loss of precision) */
-#define	FE_UNDERFLOW	0x02	/* divide-by-zero exception */
+#define	FE_UNDERFLOW	0x02	/* underflow exception */
 #define	FE_OVERFLOW	0x04	/* overflow exception */
-#define	FE_DIVBYZERO	0x08	/* underflow exception */
+#define	FE_DIVBYZERO	0x08	/* divide-by-zero exception */
 #define	FE_INVALID	0x10	/* invalid operation exception */
 
Index: /trunk/src/sys/arch/mips/include/intr.h
===================================================================
--- /trunk/src/sys/arch/mips/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: intr.h,v 1.3.96.12 2010/05/16 00:34:45 matt Exp $ */
+/* $NetBSD: intr.h,v 1.3.96.16 2011/02/05 06:31:05 cliff Exp $ */
 /*-
  * Copyright (c) 2009, 2010 The NetBSD Foundation, Inc.
@@ -32,4 +32,8 @@
 #define	_MIPS_INTR_H_
 
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
+
 /*
  * This is a common <machine/intr.h> for all MIPS platforms.
@@ -47,4 +51,6 @@
 
 #define	_IPL_N		(IPL_HIGH+1)
+#define	_IPL_NAMES(pfx)	{ pfx"none", pfx"softclock/bio", pfx"softnet/serial", \
+			  pfx"vm", pfx"sched", pfx"ddb", pfx"high" }
 
 #define	IST_UNUSABLE	-1		/* interrupt cannot be used */
@@ -62,5 +68,7 @@
 #define	IPI_SYNCICACHE	4		/* sync icache for pages */
 #define	IPI_KPREEMPT	5		/* schedule a kernel preemption */
-#define	NIPIS		6
+#define	IPI_SUSPEND	6		/* DDB suspend signaling */
+#define	IPI_HALT	7		/* halt cpu */
+#define	NIPIS		8
 
 #ifdef __INTR_PRIVATE
@@ -97,6 +105,7 @@
 
 #ifdef _KERNEL
-#ifdef MULTIPROCESSOR
-#define __HAVE_PREEMPTION
+
+#if defined(MULTIPROCESSOR) && defined(__HAVE_FAST_SOFTINTS)
+#define __HAVE_PREEMPTION	1
 #define SOFTINT_KPREEMPT	(SOFTINT_COUNT+0)
 #endif
@@ -123,4 +132,5 @@
 void	_clrsoftintr(uint32_t);
 
+struct cpu_info;
 void	ipi_init(struct cpu_info *);
 void	ipi_process(struct cpu_info *, uint64_t);
Index: /trunk/src/sys/arch/mips/include/locore.h
===================================================================
--- /trunk/src/sys/arch/mips/include/locore.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/locore.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: locore.h,v 1.78.36.1.2.24 2010/05/11 22:08:02 matt Exp $ */
+/* locore.h,v 1.78.36.1.2.29 2011/04/29 08:26:21 matt Exp */
 
 /*
@@ -21,5 +21,5 @@
  * Jump table for MIPS CPU locore functions that are implemented
  * differently on different generations, or instruction-level
- * archtecture (ISA) level, the Mips family.
+ * architecture (ISA) level, the Mips family.
  *
  * We currently provide support for MIPS I and MIPS III.
@@ -33,8 +33,56 @@
 #endif
 
+#include <mips/mutex.h>
 #include <mips/cpuregs.h>
 #include <mips/reg.h>
 
 struct tlbmask;
+struct trapframe;
+
+void	trap(uint32_t, uint32_t, vaddr_t, vaddr_t, struct trapframe *);
+void	ast(void);
+
+void	mips_fpu_trap(vaddr_t, struct trapframe *);
+void	mips_fpu_intr(vaddr_t, struct trapframe *);
+
+vaddr_t mips_emul_branch(struct trapframe *, vaddr_t, uint32_t, bool);
+void	mips_emul_inst(uint32_t, uint32_t, vaddr_t, struct trapframe *);
+
+void	mips_emul_fp(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_branchdelayslot(uint32_t, struct trapframe *, uint32_t);
+
+void	mips_emul_lwc0(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_swc0(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_special(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_special3(uint32_t, struct trapframe *, uint32_t);
+
+void	mips_emul_lwc1(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_swc1(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_ldc1(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_sdc1(uint32_t, struct trapframe *, uint32_t);
+
+void	mips_emul_lb(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_lbu(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_lh(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_lhu(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_lw(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_lwl(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_lwr(uint32_t, struct trapframe *, uint32_t);
+#if defined(__mips_n32) || defined(__mips_n64) || defined(__mips_o64)
+void	mips_emul_lwu(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_ld(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_ldl(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_ldr(uint32_t, struct trapframe *, uint32_t);
+#endif
+void	mips_emul_sb(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_sh(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_sw(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_swl(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_swr(uint32_t, struct trapframe *, uint32_t);
+#if defined(__mips_n32) || defined(__mips_n64) || defined(__mips_o64)
+void	mips_emul_sd(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_sdl(uint32_t, struct trapframe *, uint32_t);
+void	mips_emul_sdr(uint32_t, struct trapframe *, uint32_t);
+#endif
 
 uint32_t mips_cp0_cause_read(void);
@@ -64,100 +112,29 @@
 bool	mips_fixup_exceptions(mips_fixup_callback_t);
 bool	mips_fixup_zero_relative(int32_t, uint32_t [2]);
-void	mips_fixup_stubs(uint32_t *, uint32_t *,
-	    const struct mips_jump_fixup_info *, size_t);
-void	fixup_mips_cpu_switch_resume(void);
-
+void	mips_fixup_stubs(uint32_t *, uint32_t *);
+
+/*
+ * Define these stubs...
+ */
 void	mips_cpu_switch_resume(struct lwp *);
+void	tlb_set_asid(uint32_t);
+void	tlb_invalidate_all(void);
+void	tlb_invalidate_globals(void);
+void	tlb_invalidate_asids(uint32_t, uint32_t);
+void	tlb_invalidate_addr(vaddr_t);
+u_int	tlb_record_asids(u_long *, uint32_t);
+int	tlb_update(vaddr_t, uint32_t);
+void	tlb_enter(size_t, vaddr_t, uint32_t);
+void	tlb_read_indexed(size_t, struct tlbmask *);
+void	tlb_write_indexed(size_t, const struct tlbmask *);
+void	wbflush(void);
 
 #ifdef MIPS1
-void	mips1_tlb_set_asid(uint32_t);
 void	mips1_tlb_invalidate_all(void);
-void	mips1_tlb_invalidate_globals(void);
-void	mips1_tlb_invalidate_asids(uint32_t, uint32_t);
-void	mips1_tlb_invalidate_addr(vaddr_t);
-u_int	mips1_tlb_record_asids(u_long *, uint32_t);
-int	mips1_tlb_update(vaddr_t, uint32_t);
-void	mips1_tlb_enter(size_t, vaddr_t, uint32_t);
-void	mips1_tlb_read_indexed(size_t, struct tlbmask *);
-void	mips1_wbflush(void);
-void	mips1_lwp_trampoline(void);
-void	mips1_setfunc_trampoline(void);
-void	mips1_cpu_switch_resume(struct lwp *);
 
 uint32_t tx3900_cp0_config_read(void);
 #endif
 
-#if defined(MIPS3) || defined(MIPS4)
-void	mips3_tlb_set_asid(uint32_t);
-void	mips3_tlb_invalidate_all(void);
-void	mips3_tlb_invalidate_globals(void);
-void	mips3_tlb_invalidate_asids(uint32_t, uint32_t);
-void	mips3_tlb_invalidate_addr(vaddr_t);
-u_int	mips3_tlb_record_asids(u_long *, uint32_t);
-int	mips3_tlb_update(vaddr_t, uint32_t);
-void	mips3_tlb_enter(size_t, vaddr_t, uint32_t);
-void	mips3_tlb_read_indexed(size_t, struct tlbmask *);
-void	mips3_tlb_write_indexed_VPS(size_t, struct tlbmask *);
-void	mips3_wbflush(void);
-void	mips3_lwp_trampoline(void);
-void	mips3_setfunc_trampoline(void);
-void	mips3_cpu_switch_resume(struct lwp *);
-void	mips3_pagezero(void *dst);
-
-#ifdef MIPS3_5900
-void	mips5900_tlb_set_asid(uint32_t);
-void	mips5900_tlb_invalidate_all(void);
-void	mips5900_tlb_invalidate_globals(void);
-void	mips5900_tlb_invalidate_asids(uint32_t, uint32_t);
-void	mips5900_tlb_invalidate_addr(vaddr_t);
-u_int	mips5900_tlb_record_asids(u_long *, uint32_t);
-int	mips5900_tlb_update(vaddr_t, uint32_t);
-void	mips5900_tlb_enter(size_t, vaddr_t, uint32_t);
-void	mips5900_tlb_read_indexed(size_t, struct tlbmask *);
-void	mips5900_tlb_write_indexed_VPS(size_t, struct tlbmask *);
-void	mips5900_wbflush(void);
-void	mips5900_lwp_trampoline(void);
-void	mips5900_setfunc_trampoline(void);
-void	mips5900_cpu_switch_resume(struct lwp *);
-void	mips5900_pagezero(void *dst);
-#endif
-#endif
-
-#ifdef MIPS32
-void	mips32_tlb_set_asid(uint32_t);
-void	mips32_tlb_invalidate_all(void);
-void	mips32_tlb_invalidate_globals(void);
-void	mips32_tlb_invalidate_asids(uint32_t, uint32_t);
-void	mips32_tlb_invalidate_addr(vaddr_t);
-u_int	mips32_tlb_record_asids(u_long *, uint32_t);
-int	mips32_tlb_update(vaddr_t, uint32_t);
-void	mips32_tlb_enter(size_t, vaddr_t, uint32_t);
-void	mips32_tlb_read_indexed(size_t, struct tlbmask *);
-void	mips32_tlb_write_indexed_VPS(size_t, struct tlbmask *);
-void	mips32_wbflush(void);
-void	mips32_lwp_trampoline(void);
-void	mips32_setfunc_trampoline(void);
-void	mips32_cpu_switch_resume(struct lwp *);
-#endif
-
-#ifdef MIPS64
-void	mips64_tlb_set_asid(uint32_t);
-void	mips64_tlb_invalidate_all(void);
-void	mips64_tlb_invalidate_globals(void);
-void	mips64_tlb_invalidate_asids(uint32_t, uint32_t);
-void	mips64_tlb_invalidate_addr(vaddr_t);
-u_int	mips64_tlb_record_asids(u_long *, uint32_t);
-int	mips64_tlb_update(vaddr_t, uint32_t);
-void	mips64_tlb_enter(size_t, vaddr_t, uint32_t);
-void	mips64_tlb_read_indexed(size_t, struct tlbmask *);
-void	mips64_tlb_write_indexed_VPS(size_t, struct tlbmask *);
-void	mips64_wbflush(void);
-void	mips64_lwp_trampoline(void);
-void	mips64_setfunc_trampoline(void);
-void	mips64_cpu_switch_resume(struct lwp *);
-void	mips64_pagezero(void *dst);
-#endif
-
-#if defined(MIPS3) || defined(MIPS4) || defined(MIPS32) || defined(MIPS64)
+#if (MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 uint32_t mips3_cp0_compare_read(void);
 void	mips3_cp0_compare_write(uint32_t);
@@ -165,9 +142,20 @@
 uint32_t mips3_cp0_config_read(void);
 void	mips3_cp0_config_write(uint32_t);
-#if defined(MIPS32) || defined(MIPS64)
+
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 uint32_t mipsNN_cp0_config1_read(void);
 void	mipsNN_cp0_config1_write(uint32_t);
 uint32_t mipsNN_cp0_config2_read(void);
 uint32_t mipsNN_cp0_config3_read(void);
+
+uintptr_t mipsNN_cp0_watchlo_read(u_int);
+void	mipsNN_cp0_watchlo_write(u_int, uintptr_t);
+uint32_t mipsNN_cp0_watchhi_read(u_int);
+void	mipsNN_cp0_watchhi_write(u_int, uint32_t);
+
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+void	mipsNN_cp0_hwrena_write(uint32_t);
+void	mipsNN_cp0_userlocal_write(void *);
+#endif
 #endif
 
@@ -246,11 +234,9 @@
 void	mips3_sd(volatile uint64_t *, uint64_t);
 #endif	/* __GNUC__ */
-#endif	/* MIPS3 || MIPS4 || MIPS32 || MIPS64 */
-
-#if defined(MIPS3) || defined(MIPS4) || defined(MIPS64)
-static __inline uint32_t	mips3_lw_a64(uint64_t addr)
-		    __attribute__((__unused__));
-static __inline void	mips3_sw_a64(uint64_t addr, uint32_t val)
-		    __attribute__ ((__unused__));
+#endif	/* (MIPS3 + MIPS4 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
+
+#if (MIPS3 + MIPS4 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+static __inline uint32_t	mips3_lw_a64(uint64_t addr) __unused;
+static __inline void	mips3_sw_a64(uint64_t addr, uint32_t val) __unused;
 
 static __inline uint32_t
@@ -328,5 +314,5 @@
 #endif
 }
-#endif	/* MIPS3 || MIPS4 || MIPS64 */
+#endif	/* (MIPS3 + MIPS4 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 
 /*
@@ -335,4 +321,8 @@
  */
 typedef struct  {
+	void	(*ljv_cpu_switch_resume)(struct lwp *);
+	intptr_t ljv_lwp_trampoline;
+	intptr_t ljv_setfunc_trampoline;
+	void	(*ljv_wbflush)(void);
 	void	(*ljv_tlb_set_asid)(uint32_t pid);
 	void	(*ljv_tlb_invalidate_asids)(uint32_t, uint32_t);
@@ -344,6 +334,17 @@
 	void	(*ljv_tlb_enter)(size_t, vaddr_t, uint32_t);
 	void	(*ljv_tlb_read_indexed)(size_t, struct tlbmask *);
-	void	(*ljv_wbflush)(void);
+	void	(*ljv_tlb_write_indexed)(size_t, const struct tlbmask *);
 } mips_locore_jumpvec_t;
+
+typedef struct {
+	u_int	(*lav_atomic_cas_uint)(volatile u_int *, u_int, u_int);
+	u_long	(*lav_atomic_cas_ulong)(volatile u_long *, u_long, u_long);
+	int	(*lav_ucas_uint)(volatile u_int *, u_int, u_int, u_int *);
+	int	(*lav_ucas_ulong)(volatile u_long *, u_long, u_long, u_long *);
+	void	(*lav_mutex_enter)(kmutex_t *);
+	void	(*lav_mutex_exit)(kmutex_t *);
+	void	(*lav_mutex_spin_enter)(kmutex_t *);
+	void	(*lav_mutex_spin_exit)(kmutex_t *);
+} mips_locore_atomicvec_t;
 
 void	mips_set_wbflush(void (*)(void));
@@ -357,11 +358,11 @@
 
 struct locoresw {
-	void		(*lsw_cpu_switch_resume)(struct lwp *);
-	uintptr_t	lsw_lwp_trampoline;
+	void		(*lsw_wbflush)(void);
 	void		(*lsw_cpu_idle)(void);
-	uintptr_t	lsw_setfunc_trampoline;
 	int		(*lsw_send_ipi)(struct cpu_info *, int);
 	void		(*lsw_cpu_offline_md)(void);
 	void		(*lsw_cpu_init)(struct cpu_info *);
+	void		(*lsw_cpu_run)(struct cpu_info *);
+	int		(*lsw_bus_error)(unsigned int);
 };
 
@@ -373,98 +374,24 @@
 
 /*
- * The "active" locore-fuction vector, and
- */
+ * The "active" locore-function vector, and
+ */
+extern const mips_locore_atomicvec_t mips_llsc_locore_atomicvec;
+extern const mips_locore_atomicvec_t mips_ras_locore_atomicvec;
+
+extern mips_locore_atomicvec_t mips_locore_atomicvec;
 extern mips_locore_jumpvec_t mips_locore_jumpvec;
 extern struct locoresw mips_locoresw;
-extern void mips_vector_init(const struct splsw *);
-
-#if    defined(MIPS1) && !defined(MIPS3) && !defined(MIPS32) && !defined(MIPS64)
-#define tlb_set_asid		mips1_tlb_set_asid
-#define tlb_invalidate_asids	mips1_tlb_invalidate_asids
-#define tlb_invalidate_addr	mips1_tlb_invalidate_addr
-#define tlb_invalidate_globals	mips1_tlb_invalidate_globals
-#define tlb_invalidate_all	mips1_tlb_invalidate_all
-#define tlb_record_asids	mips1_tlb_record_asids
-#define tlb_update		mips1_tlb_update
-#define tlb_enter		mips1_tlb_enter
-#define tlb_read_indexed	mips1_tlb_read_indexed
-#define wbflush			mips1_wbflush
-#define lwp_trampoline		mips1_lwp_trampoline
-#define setfunc_trampoline	mips1_setfunc_trampoline
-#elif !defined(MIPS1) &&  defined(MIPS3) && !defined(MIPS32) && !defined(MIPS64) && !defined(MIPS3_5900)
-#define tlb_set_asid		mips3_tlb_set_asid
-#define tlb_invalidate_asids	mips3_tlb_invalidate_asids
-#define tlb_invalidate_addr	mips3_tlb_invalidate_addr
-#define tlb_invalidate_globals	mips3_tlb_invalidate_globals
-#define tlb_invalidate_all	mips3_tlb_invalidate_all
-#define tlb_record_asids	mips3_tlb_record_asids
-#define tlb_update		mips3_tlb_update
-#define tlb_enter		mips3_tlb_enter
-#define tlb_read_indexed	mips3_tlb_read_indexed
-#define tlb_write_indexed_VPS	mips3_tlb_write_indexed_VPS
-#define lwp_trampoline		mips3_lwp_trampoline
-#define setfunc_trampoline	mips3_setfunc_trampoline
-#define wbflush			mips3_wbflush
-#elif !defined(MIPS1) && !defined(MIPS3) &&  defined(MIPS32) && !defined(MIPS64)
-#define tlb_set_asid		mips32_tlb_set_asid
-#define tlb_invalidate_asids	mips32_tlb_invalidate_asids
-#define tlb_invalidate_addr	mips32_tlb_invalidate_addr
-#define tlb_invalidate_globals	mips32_tlb_invalidate_globals
-#define tlb_invalidate_all	mips32_tlb_invalidate_all
-#define tlb_record_asids	mips32_tlb_record_asids
-#define tlb_update		mips32_tlb_update
-#define tlb_enter		mips32_tlb_enter
-#define tlb_read_indexed	mips32_tlb_read_indexed
-#define tlb_write_indexed_VPS	mips32_tlb_write_indexed_VPS
-#define lwp_trampoline		mips32_lwp_trampoline
-#define setfunc_trampoline	mips32_setfunc_trampoline
-#define wbflush			mips32_wbflush
-#elif !defined(MIPS1) && !defined(MIPS3) && !defined(MIPS32) &&  defined(MIPS64)
- /* all common with mips3 */
-#define tlb_set_asid		mips64_tlb_set_asid
-#define tlb_invalidate_asids	mips64_tlb_invalidate_asids
-#define tlb_invalidate_addr	mips64_tlb_invalidate_addr
-#define tlb_invalidate_globals	mips64_tlb_invalidate_globals
-#define tlb_invalidate_all	mips64_tlb_invalidate_all
-#define tlb_record_asids	mips64_tlb_record_asids
-#define tlb_update		mips64_tlb_update
-#define tlb_enter		mips64_tlb_enter
-#define tlb_read_indexed	mips64_tlb_read_indexed
-#define tlb_write_indexed_VPS	mips64_tlb_write_indexed_VPS
-#define lwp_trampoline		mips64_lwp_trampoline
-#define setfunc_trampoline	mips64_setfunc_trampoline
-#define wbflush			mips64_wbflush
-#elif !defined(MIPS1) &&  defined(MIPS3) && !defined(MIPS32) && !defined(MIPS64) && defined(MIPS3_5900)
-#define tlb_set_asid		mips5900_tlb_set_asid
-#define tlb_invalidate_asids	mips5900_tlb_invalidate_asids
-#define tlb_invalidate_addr	mips5900_tlb_invalidate_addr
-#define tlb_invalidate_globals	mips5900_tlb_invalidate_globals
-#define tlb_invalidate_all	mips5900_tlb_invalidate_all
-#define tlb_record_asids	mips5900_tlb_record_asids
-#define tlb_update		mips5900_tlb_update
-#define tlb_enter		mips5900_tlb_enter
-#define tlb_read_indexed	mips5900_tlb_read_indexed
-#define tlb_write_indexed_VPS	mips5900_tlb_write_indexed_VPS
-#define lwp_trampoline		mips5900_lwp_trampoline
-#define setfunc_trampoline	mips5900_setfunc_trampoline
-#define wbflush			mips5900_wbflush
-#else
-#define tlb_set_asid		(*mips_locore_jumpvec.ljv_tlb_set_asid)
-#define tlb_invalidate_asids	(*mips_locore_jumpvec.ljv_tlb_invalidate_asids)
-#define tlb_invalidate_addr	(*mips_locore_jumpvec.ljv_tlb_invalidate_addr)
-#define tlb_invalidate_globals	(*mips_locore_jumpvec.ljv_tlb_invalidate_globals)
-#define tlb_invalidate_all	(*mips_locore_jumpvec.ljv_tlb_invalidate_all)
-#define tlb_record_asids	(*mips_locore_jumpvec.ljv_tlb_record_asids)
-#define tlb_update		(*mips_locore_jumpvec.ljv_tlb_update)
-#define tlb_enter		(*mips_locore_jumpvec.ljv_tlb_enter)
-#define tlb_read_indexed	(*mips_locore_jumpvec.ljv_tlb_read_indexed)
-#define wbflush			(*mips_locore_jumpvec.ljv_wbflush)
-#define lwp_trampoline		mips_locoresw.lsw_lwp_trampoline
-#define setfunc_trampoline	mips_locoresw.lsw_setfunc_trampoline
-#endif
-
-#define CPU_IDLE		mips_locoresw.lsw_cpu_idle
-
-/* cpu_switch_resume is called inside locore.S */
+
+struct splsw;
+struct mips_vmfreelist;
+struct phys_ram_seg;
+
+void	mips_vector_init(const struct splsw *, bool);
+void	mips_init_msgbuf(void);
+void	mips_init_lwp0_uarea(void);
+void	mips_page_physload(vaddr_t, vaddr_t,
+	    const struct phys_ram_seg *, size_t,
+	    const struct mips_vmfreelist *, size_t);
+
 
 /*
@@ -613,5 +540,13 @@
 #define  MIPS_CP0FL_EBASE	__BIT(5)
 #define  MIPS_CP0FL_CONFIG	__BIT(6)
-#define  MIPS_CP0FL_CONFIGn(n)	(__BIT(7) << ((n) & 7))
+#define  MIPS_CP0FL_CONFIG1	__BIT(7)
+#define  MIPS_CP0FL_CONFIG2	__BIT(8)
+#define  MIPS_CP0FL_CONFIG3	__BIT(9)
+#define  MIPS_CP0FL_CONFIG4	__BIT(10)
+#define  MIPS_CP0FL_CONFIG5	__BIT(11)
+#define  MIPS_CP0FL_CONFIG6	__BIT(12)
+#define  MIPS_CP0FL_CONFIG7	__BIT(13)
+#define  MIPS_CP0FL_USERLOCAL	__BIT(14)
+#define  MIPS_CP0FL_HWRENA	__BIT(15)
 
 /*
@@ -621,8 +556,8 @@
  * RMI company-specific cpu_cidflags
  */
-#define MIPS_CIDFL_RMI_TYPE     	__BITS(2,0)
-# define  CIDFL_RMI_TYPE_XLR     	0
-# define  CIDFL_RMI_TYPE_XLS     	1
-# define  CIDFL_RMI_TYPE_XLP     	2
+#define MIPS_CIDFL_RMI_TYPE		__BITS(2,0)
+# define  CIDFL_RMI_TYPE_XLR		0
+# define  CIDFL_RMI_TYPE_XLS		1
+# define  CIDFL_RMI_TYPE_XLP		2
 #define MIPS_CIDFL_RMI_THREADS_MASK	__BITS(6,3)
 # define MIPS_CIDFL_RMI_THREADS_SHIFT	3
Index: /trunk/src/sys/arch/mips/include/math.h
===================================================================
--- /trunk/src/sys/arch/mips/include/math.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/math.h	(revision 152)
@@ -1,3 +1,6 @@
-/*	$NetBSD: math.h,v 1.4 2002/02/19 13:08:14 simonb Exp $	*/
+/*	$NetBSD: math.h,v 1.4.140.1 2011/04/29 07:48:37 matt Exp $	*/
 
 #define	__HAVE_NANF
+#if defined(__mips_n32) || defined(__mips_n64)
+#define __HAVE_LONG_DOUBLE
+#endif
Index: /trunk/src/sys/arch/mips/include/mcontext.h
===================================================================
--- /trunk/src/sys/arch/mips/include/mcontext.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/mcontext.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mcontext.h,v 1.8.18.4 2010/04/30 16:32:16 matt Exp $	*/
+/*	$NetBSD: mcontext.h,v 1.8.18.5 2011/04/29 08:26:21 matt Exp $	*/
 
 /*-
@@ -126,4 +126,8 @@
 	__gregset_t	__gregs;
 	__fpregset_t	__fpregs;
+	__greg_t	_mc_tlsbase;
+#if !__mips_n32
+	__greg_t	__mc_unused;
+#endif
 } mcontext_t;
 
@@ -135,4 +139,6 @@
 	__gregset32_t		__gregs;
 	struct __fpregset_oabi	__fpregs;
+	__greg32_t		_mc_tlsbase;
+	__greg32_t		__mc_unused;
 } mcontext_o32_t;
 
@@ -140,4 +146,5 @@
 	__gregset_t		__gregs;
 	struct __fpregset_nabi	__fpregs;
+	__greg_t		_mc_tlsbase;
 } mcontext32_t;
 
@@ -146,8 +153,9 @@
 #endif /* !__ASSEMBLER__ */
 
-#define _UC_MACHINE_PAD	16	/* Padding appended to ucontext_t */
+#define _UC_MACHINE_PAD		14	/* Padding appended to ucontext_t */
 
 #define	_UC_SETSTACK	0x00010000
 #define	_UC_CLRSTACK	0x00020000
+#define	_UC_TLSBASE	0x00040000
 
 #define _UC_MACHINE_SP(uc)	((uc)->uc_mcontext.__gregs[_REG_SP])
@@ -160,6 +168,60 @@
 #define _UC_MACHINE32_PC(uc)	_UC_MACHINE_PC(uc)
 #define _UC_MACHINE32_INTRV(uc)	_UC_MACHINE_INTRV(uc)
+#define _UC_MACHINE32_PAD	14	/* Padding appended to ucontext32_t */
 
 #define	_UC_MACHINE32_SET_PC(uc, pc)	_UC_MACHINE_PC((uc), (pc))
 
+#define	__UCONTEXT_SIZE_O32	(40 + 296 +  56)	/* 392 */
+#define	__UCONTEXT_SIZE_N32	(40 + 568 +  56)	/* 664 */
+#define	__UCONTEXT_SIZE_N64	(56 + 576 + 112)	/* 774 */
+
+#ifdef __mips_o32
+#define	__UCONTEXT_SIZE		__UCONTEXT_SIZE_O32
+#elif __mips_n32
+#define	__UCONTEXT_SIZE		__UCONTEXT_SIZE_N32
+#elif __mips_n64
+#define	__UCONTEXT_SIZE		__UCONTEXT_SIZE_N64
+#define	__UCONTEXT32_SIZE	__UCONTEXT_SIZE_N32
+#elif
+#error O64 is not supported
+#endif
+
+#if defined(_LIBC_SOURCE) || defined(_RTLD_SOURCE) || defined(__LIBPTHREAD_SOURCE__)
+#define	TLS_TP_OFFSET	0x7000
+#define	TLS_DTV_OFFSET	0x8000
+
+#include <sys/tls.h>
+
+__CTASSERT(TLS_TP_OFFSET + sizeof(struct tls_tcb) < 0x8000);
+__CTASSERT(TLS_TP_OFFSET % sizeof(struct tls_tcb) == 0);
+
+static __inline struct tls_tcb *
+__lwp_gettcb_fast(void)
+{
+	struct tls_tcb *__tcb;
+
+	/*
+	 * Only emit a rdhwr $3, $29 so the kernel can quickly emulate it.
+	 */
+	__asm __volatile(".set push; .set mips32r2; "
+		"rdhwr $3,$29; .set pop;"
+#ifdef _LP64
+		"daddiu %[__tcb],$3,%1"
+#else
+		"addiu %[__tcb],$3,%1"
+#endif
+	    : [__tcb]"=r"(__tcb)
+	    : [__offset]"n"(-(TLS_TP_OFFSET + sizeof(*__tcb)))
+	    : "v1");
+	return __tcb;
+}
+
+static inline void
+__lwp_settcb(struct tls_tcb *__tcb)
+{
+	__tcb += TLS_TP_OFFSET / sizeof(*__tcb) + 1;
+	_lwp_setprivate(__tcb);
+}
+#endif
+
 #endif	/* _MIPS_MCONTEXT_H_ */
Index: /trunk/src/sys/arch/mips/include/mips_opcode.h
===================================================================
--- /trunk/src/sys/arch/mips/include/mips_opcode.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/mips_opcode.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mips_opcode.h,v 1.12.96.1 2010/05/15 20:27:48 matt Exp $	*/
+/*	$NetBSD: mips_opcode.h,v 1.12.96.3 2011/04/29 08:26:21 matt Exp $	*/
 
 /*-
@@ -174,5 +174,5 @@
 #define OP_LWC1		061
 #define OP_LWC2		062
-#define OP_LWC3		063
+#define OP_PREF		063
 #define OP_LLD		064		/* MIPS-II, for r4000 port */
 #define OP_LDC1		065
@@ -183,5 +183,5 @@
 #define OP_SWC1		071
 #define OP_SWC2		072
-#define OP_SWC3		073
+#define OP_RSVD073	073
 #define OP_SCD		074		/* MIPS-II, for r4000 port */
 #define OP_SDC1		075
@@ -295,10 +295,12 @@
 #define OP_MF		000
 #define OP_DMF		001		/* MIPS-II, for r4000 port */
+#define	OP_CF		002
+#define	OP_MFH		003
 #define OP_MT		004
 #define OP_DMT		005		/* MIPS-II, for r4000 port */
+#define	OP_CT		006
+#define	OP_MTH		007
 #define OP_BCx		010
 #define OP_BCy		014
-#define OP_CF		002
-#define OP_CT		006
 
 /*
Index: /trunk/src/sys/arch/mips/include/mips_param.h
===================================================================
--- /trunk/src/sys/arch/mips/include/mips_param.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/mips_param.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mips_param.h,v 1.23.78.5 2010/02/05 07:36:51 matt Exp $	*/
+/*	$NetBSD: mips_param.h,v 1.23.78.6 2010/08/16 18:01:13 matt Exp $	*/
 
 #ifdef _KERNEL
@@ -70,5 +70,12 @@
 #define NBSEG		(NBPG*NPTEPG)	/* bytes/segment */
 #define	SEGOFSET	(NBSEG-1)	/* byte offset into segment */
-#define	SEGSHIFT	(2*PGSHIFT-2)	/* LOG2(NBSEG) */
+#define	SEGSHIFT	(PGSHIFT+(PGSHIFT-2))	/* LOG2(NBSEG) */
+
+#ifdef _LP64
+#define	NSEGPG		(NBPG/8)
+#define NBXSEG		(NSEGPG*NBSEG)	/* bytes/xsegment */
+#define	XSEGOFSET	(NBSEG-1)	/* byte offset into segment */
+#define	XSEGSHIFT	(SEGSHIFT+(PGSHIFT-3))	/* LOG2(NBXSEG) */
+#endif
 
 /*
Index: /trunk/src/sys/arch/mips/include/pcb.h
===================================================================
--- /trunk/src/sys/arch/mips/include/pcb.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/pcb.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pcb.h,v 1.20.62.3 2010/02/15 03:09:59 matt Exp $	*/
+/*	$NetBSD: pcb.h,v 1.20.62.5 2010/08/16 23:38:01 matt Exp $	*/
 
 /*
@@ -83,4 +83,12 @@
 #include <mips/reg.h>
 
+struct pcb_faultinfo {
+	void *pfi_faultpte;
+	vaddr_t pfi_faultaddr;
+	u_int pfi_repeats;
+	pid_t pfi_lastpid;
+	uint8_t pfi_faulttype;
+};
+
 /*
  * MIPS process control block
@@ -91,4 +99,5 @@
 	uint32_t pcb_ppl;		/* previous priority level */
 	struct fpreg pcb_fpregs;	/* saved floating point registers */
+	struct pcb_faultinfo pcb_faultinfo;
 };
 
